#include "Structures.h"
#include "date.h"

Date::Date()
{
    day = month = year = 0;
}

void Date::Update(int d, int m, int y)
{
    if ( m > 0 && m <=12)
        month = m;
    else
    {
        month = 1;
    }

    year = y;
    day = CheckDay(d);

}

void Date::SetDay(int d)
{
    day = CheckDay(d);
}

void Date::SetMonth(int m)
{
    if ( m > 0 && m <=12)
        month = m;
    else
    {
        month = 1;
    }

}

void Date::SetYear(int y)
{
    year = y;
}

int Date::GetDay() const
{
    return day;
}

int Date::GetMonth() const
{
    return month;
}

int Date::GetYear() const
{
    return year;
}

void Date::Refresh()
{
    day = month = year = 0;
}

void Date::Version(SVersion * Version)
{
   Version->Major = 1;
   Version->Minor = 0;
   Version->Patch = 0;
}

Date::~Date()
{
    day = month = year = 0;
}

int Date::CheckDay(int day_to_test)
{
    static const int DaysPerMonth[] = {0,31,28,31,30,31,30, 31, 31, 30, 31, 30, 31};

    if (day_to_test>0 && day_to_test <= DaysPerMonth[month])
        return day_to_test;

    if (month == 2 && day_to_test == 29 &&
        (year % 400 == 0 ||
        (year % 4 ==0 && year % 100 !=  0)))
        return day_to_test;

    return 1;

}
